<template>
  <div class="main">
    <ModalsUsersCreate
      v-model:visible="modalUserCreate"
      @action:toggle="getAllUsersRefresh()"
    />

    <ModalsUsersEdit
      v-model:visible="modalUserEdit"
      @action:toggle="getAllUsersRefresh()"
      :userId="userId"
    />

    <div class="container">
      <DataTable
        :value="users?.data"
        tableStyle="min-width: 50rem"
        removableSort
        showGridlines
        :loading="getAllUsersLoading"
        @sort="sorted"
      >
        <template #header>
          <div class="flex gap-5">
            <PrimeButton label="Создать" @click="modalUserCreate = true" />
            <PrimeButton
              severity="secondary"
              label="Обновить"
              @click="getAllUsersRefresh()"
              :loading="getAllUsersLoading"
            />
          </div>
        </template>

        <Column field="id" header="#" sortable></Column>
        <Column field="email" header="E-mail" sortable></Column>
        <Column field="role" header="Роль" sortable>
          <template #body="{ data }">
            {{ getRoleName(data.role) }}
          </template>
        </Column>
        <Column style="text-align: center">
          <template #body="{ data }">
            <PrimeButton label="Редактировать" @click="editUser(data.id)" />
            <PrimeButton
              class="ml-4"
              label="Удалить"
              severity="danger"
              @click="destroyUser(data.id)"
            />
          </template>
        </Column>
      </DataTable>

      <Paginator
        class="mt-4"
        :totalRecords="users?.pagination?.total ?? 0"
        :rows="10"
        :rowsPerPageOptions="[10, 20, 30]"
        @page="paginate"
      ></Paginator>
    </div>
  </div>
</template>

<script lang="ts" setup>
import useToast from '~/hooks/primevue/useToastP'
import DataTable from 'primevue/datatable'
import Column from 'primevue/column'

import { useUserStore } from '~/stores/user'

const { getAll, destroy, getRoleName } = useUserStore()

const toast = useToast()
const { sort } = useSort()

const modalUserCreate = ref(false)
const modalUserEdit = ref(false)

const params = reactive({
  page: 0,
  limit: 10,
  sort_key: 'id',
  sort_order: 'asc'
})

const userId = ref(0)

const {
  data: users,
  refresh: getAllUsersRefresh,
  loadingAsync: getAllUsersLoading
} = await useLazyAsyncDataFetch('users', () => getAll(params), {
  server: false,
  cache: true,
  onResponseError(error) {
    toast.error(error.message, error.detail)
  }
})

const { execute: destroyUserExecute } = await useAsyncDataFetch(
  () => destroy(userId.value),
  {
    immediate: false,
    onResponseError(error) {
      toast.error(error.message, error.detail)
    },
    onResponseSuccess() {
      toast.success('Пользователь успешно удален')
      getAllUsersRefresh()
    }
  }
)

const editUser = (id: number) => {
  userId.value = id
  modalUserEdit.value = true
}

const destroyUser = (id: number) => {
  userId.value = id

  destroyUserExecute()
}

const sorted = async (value: any) => {
  sort(value, params)

  await getAllUsersRefresh()
}

const paginate = async (paginate: any) => {
  params.page = ++paginate.page
  params.limit = paginate.rows

  await getAllUsersRefresh()
}
</script>
